Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab	(revision 698)
@@ -1,5 +1,4 @@
 Namespace System
 Namespace Drawing
-
 
 /**
@@ -8,177 +7,137 @@
 */
 
-Class FontFamily : End Class
-Class FontCollection : End Class
+Class FontCollection
+Public
+	nativeCollection As *GpFontCollection
+End Class
 
 Class Font
 	Implements System.IDisposable
 Public
-'	 friend class Graphics
-
-	Sub Font(/*IN*/ hdc As HDC)
+	Static Function FromHDC(/*IN*/ hdc As HDC) As Font
 		Dim font = 0 As *GpFont
-		lastResult = GdipCreateFontFromDC(hdc, font)
-		SetNativeFont(font)
-	End Sub
-
-	Sub Font(/*IN*/ hdc As HDC, /*IN const*/ ByRef logfont As LOGFONTA)
+		SetStatus(GdipCreateFontFromDC(hdc, font))
+		FromHDC = New Font(font)
+	End Function
+
+	Static Function FromLogFont(/*IN*/ hdc As HDC, /*IN const*/ ByRef logfont As LOGFONTA) As Font
 		Dim font = 0 As *GpFont
-		lastResult =GdipCreateFontFromLogfontA(hdc, logfont, font)
-		SetNativeFont(font)
-	End Sub
-
-	Sub Font(/*IN*/ hdc As HDC, /*IN const*/ ByRef logfont As LOGFONTW)
+		SetStatus(GdipCreateFontFromLogfontA(hdc, logfont, font))
+		FromLogFont = New Font(font)
+	End Function
+
+	Static Function FromLogFont(/*IN*/ hdc As HDC, /*IN const*/ ByRef logfont As LOGFONTW) As Font
 		Dim font = 0 As *GpFont
-		lastResult =GdipCreateFontFromLogfontW(hdc, logfont, font)
-		SetNativeFont(font)
-	End Sub
-
-	Sub Font(/*IN*/ hdc As HDC, /*IN const*/ hfont As HFONT)
+		SetStatus(GdipCreateFontFromLogfontW(hdc, logfont, font))
+		FromLogFont = New Font(font)
+	End Function
+
+	Static Function FromHFont(/*IN*/ hdc As HDC, /*IN const*/ hfont As HFONT) As Font
 		Dim font = 0 As *GpFont
 		If hfont <> 0 Then
 			Dim lf As LOGFONTA
-			If GetObjectA(hfont, sizeof (LOGFONTA), lf) <> 0 Then
-				lastResult = GdipCreateFontFromLogfontA(hdc, lf, font)
+			If GetObjectA(hfont, Len(lf), lf) <> 0 Then
+				SetStatus(GdipCreateFontFromLogfontA(hdc, lf, font))
 			Else
-				lastResult = GdipCreateFontFromDC(hdc, font)
+				SetStatus(GdipCreateFontFromDC(hdc, font))
 			End If
 		Else
-			lastResult = GdipCreateFontFromDC(hdc, font)
-		End If
-		SetNativeFont(font)
+			SetStatus(GdipCreateFontFromDC(hdc, font))
+		End If
+		FromHFont = New Font(font)
+	End Function
+
+	Sub Font(f As *GpFont)
+		nativeFont = f
 	End Sub
 
 	Sub Font(/*IN const*/ family As FontFamily, /*IN*/ emSize As Single)
-		Font(family, emSize, FontStyleRegular, UnitPoint)
-	End Sub
-
-	Sub Font(/*IN const*/ family As FontFamily,
-		/*IN*/ emSize As Single, /*IN*/ style As Long)
-
-		Font(family, emSize, style, UnitPoint)
+		initFont(family, emSize, FontStyle.Regular, GraphicsUnit.Point)
+	End Sub
+
+	Sub Font(/*IN const*/ family As FontFamily, /*IN*/ emSize As Single, /*IN*/ style As FontStyle)
+		initFont(family, emSize, style, GraphicsUnit.Point)
+	End Sub
+
+	Sub Font(/*IN const*/ family As FontFamily, /*IN*/ emSize As Single, /*IN*/ unit As GraphicsUnit)
+		initFont(family, emSize, FontStyle.Regular, unit)
 	End Sub
 
 	Sub Font(/*IN const*/ family As FontFamily, /*IN*/ emSize As Single,
-		/*IN*/ style As Long, /*IN*/ unit As GraphicsUnit)
-
-		Dim font = 0 As *GpFont
-		lastResult = GdipCreateFont(
-			family.NativeFamily, emSize, style, unit, font)
-		SetNativeFont(font)
+		/*IN*/ style As FontStyle, /*IN*/ unit As GraphicsUnit)
+
+		initFont(family, emSize, style, unit)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single)
-		Font(familyName, emSize, FontStyleRegular, Unit.Point, ByVal 0)
+		initFromName(familyName, emSize, FontStyle.Regular, GraphicsUnit.Point, Nothing)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single)
-		Font(familyName, emSize, FontStyleRegular, Unit.Point, ByVal 0)
+		initFromName(ToWCStr(familyName), emSize, FontStyle.Regular, GraphicsUnit.Point, Nothing)
+	End Sub
+
+	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single, /*IN*/ style As FontStyle)
+		initFromName(familyName, emSize, style, GraphicsUnit.Point, Nothing)
+	End Sub
+
+	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single, /*IN*/ style As FontStyle)
+		initFromName(ToWCStr(familyName), emSize, style, GraphicsUnit.Point, Nothing)
+	End Sub
+
+	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single, /*IN*/ unit As GraphicsUnit)
+		initFromName(familyName, emSize, FontStyle.Regular, unit, Nothing)
+	End Sub
+
+	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single, /*IN*/ unit As GraphicsUnit)
+		initFromName(ToWCStr(familyName), emSize, FontStyle.Regular, unit, Nothing)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single,
-		 /*IN*/ style As Long)
-		Font(familyName, emSize, style, Unit.Point, ByVal 0)
+		 /*IN*/ style As FontStyle, /*IN*/ unit As GraphicsUnit)
+
+		initFromName(familyName, emSize, style, unit, Nothing)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single,
-		 /*IN*/ style As Long)
-		Font(familyName, emSize, style, Unit.Point, ByVal 0)
+		 /*IN*/ style As FontStyle, /*IN*/ unit As GraphicsUnit)
+
+		initFromName(ToWCStr(familyName), emSize, style, unit, Nothing)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single,
-		 /*IN*/ style As Long, /*IN*/ unit As GraphicsUnit)
-		Font(familyName, emSize, style, unit, ByVal 0)
+		/*IN*/ style As FontStyle, /*IN*/ unit As GraphicsUnit,
+		/*IN const*/ fontCollection As FontCollection)
+
+		initFromName(familyName, emSize, style, unit, fontCollection)
 	End Sub
 
 	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single,
-		 /*IN*/ style As Long, /*IN*/ unit As GraphicsUnit)
-		Font(familyName, emSize, style, unit, ByVal 0)
-	End Sub
-
-	Sub Font(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single,
-		/*IN*/ style As Long, /*IN*/ unit As GraphicsUnit,
-		/*IN const*/ ByRef fontCollection As FontCollection)
-
-		nativeFont = 0
-
-		Dim family As FontFamily(familyName, fontCollection)
-		Dim nativeFamily = family.NativeFamily As *GpFontFamily
-
-		lastResult = family.GetLastStatus()
-
-		If lastResult <> Ok Then
-			nativeFamily = FontFamily.GenericSansSerif()->NativeFamily
-			lastResult = FontFamily.GenericSansSerif()->lastResult
-			If lastResult <> Ok Then
-				Exit Sub
-			End If
-		End If
-
-		lastResult = GdipCreateFont(
-			nativeFamily, emSize, style, unit, nativeFont)
-
-		If lastResult <> Ok Then
-			nativeFamily = FontFamily.GenericSansSerif()->NativeFamily
-			lastResult = FontFamily.GenericSansSerif()->lastResult
-			If lastResult <> Ok Then
-				Exit Sub
-			End If
-
-			lastResult = GdipCreateFont(
-				nativeFamily, emSize, style, unit, nativeFont)
-		End If
-	End Sub
-
-	Sub Font(/*IN const*/ familyName As String, /*IN*/ emSize As Single,
-		/*IN*/ style As Long, /*IN*/ unit As GraphicsUnit,
+		/*IN*/ style As FontStyle, /*IN*/ unit As GraphicsUnit,
 		/*IN const*/ fontCollection As FontCollection)
-		Font(ToWCStr(familyName), emSize, style, unit, fontCollection)
-	End Sub
-
-	Const Function GetLogFontA(/*IN const*/ g As Graphics, /*OUT*/ ByRef lf As LOGFONTA) As Status
-		Dim nativeGraphics As *GpGraphics
-		If Not ActiveBasic.IsNothing(g) Then
-			nativeGraphics = g.nativeGraphics
-		End If
-		Return SetStatus(GdipGetLogFontA(nativeFont, nativeGraphics, lf))
-	End Function
-
-	Const Function GetLogFontW(/*IN const*/ g As Graphics, /*OUT*/ ByRef lf As LOGFONTW) As Status
-		Dim nativeGraphics As *GpGraphics
-		If Not ActiveBasic.IsNothing(g) Then
-			nativeGraphics = g.nativeGraphics
-		End If
-		Return SetStatus(GdipGetLogFontW(nativeFont, nativeGraphics, lf))
-	End Function
-
-	Const Function GetLogFont(/*IN const*/ g As Graphics, /*OUT*/ ByRef lf As LOGFONT) As Status
-		Dim nativeGraphics As *GpGraphics
-		If Not ActiveBasic.IsNothing(g) Then
-			nativeGraphics = g.nativeGraphics
-		End If
-#ifdef UNICODE
-		Return SetStatus(GdipGetLogFontW(nativeFont, nativeGraphics, lf))
-#else
-		Return SetStatus(GdipGetLogFontA(nativeFont, nativeGraphics, lf))
-#endif
-	End Function
+
+		initFromName(ToWCStr(familyName), emSize, style, unit, fontCollection)
+	End Sub
 
 	Const Function Clone() As Font
 		Dim cloneFont = 0 As *GpFont
 		SetStatus(GdipCloneFont(nativeFont, cloneFont))
-		Return New Font(cloneFont, lastResult)
-	End Function
+		Clone = New Font(cloneFont)
+	End Function
+
+	Sub Dispose()
+		If nativeFont <> 0 Then
+			GdipDeleteFont(nativeFont)
+		End If
+		nativeFont = 0
+	End Sub
 
 	Sub ~Font()
-		GdipDeleteFont(nativeFont)
-	End Sub
-
-	Const Function IsAvailable() As Boolean
-		Return nativeFont <> 0
-	End Function
-
-	Const Function Style() As Long
-		SetStatus(GdipGetFontStyle(nativeFont, Style))
-	End Function
+		Dispose()
+	End Sub
+
+'	Const Function Style() As FontStyle
+'		SetStatus(GdipGetFontStyle(nativeFont, Style))
+'	End Function
 
 	Const Function Size() As Single
@@ -186,16 +145,13 @@
 	End Function
 
-	Const Function SizeInPoints() As Single
-
-	Const Function Unit() As GraphicsUnit
-		SetStatus(GdipGetFontUnit(nativeFont, Unit))
-	End Function
-
-	Const Function LastStatus() As Status
-		Return lastResult
-	End Function
+'	Const Function SizeInPoints() As Single
+'	End Function
+
+'	Const Function Unit() As GraphicsUnit
+'		SetStatus(GdipGetFontUnit(nativeFont, Unit))
+'	End Function
 
 	Const Function Height() As Long
-		Return GetHeight() As Long
+		Height = GetHeight() As Long
 	End Function
 
@@ -205,8 +161,5 @@
 
 	Const Function GetHeight(/*IN const*/ g As Graphics) As Single
-		Dim nativeGraphics As *GpGraphics
-		If Not ActiveBasic.IsNothing(g) Then
-			nativeGraphics = g.NativeGraphics
-		End If
+		Dim nativeGraphics = getNativeGraphics(g)
 		SetStatus(GdipGetFontHeight(nativeFont, nativeGraphics, GetHeight))
 	End Function
@@ -216,16 +169,13 @@
 	End Function
 
-'	 Const Function FontFamily(/*OUT*/ ByRef family As FontFamily)
-'		If VarPtr(family) = 0 Then
-'			Return SetStatus(Status.InvalidParameter)
-'		End If
-'		Dim status = GdipGetFamily(nativeFont, family->nativeFamily)
-'		family->SetStatus(status)
-'		Return SetStatus(status)
+'	 Const Function FontFamily() As FontFamily
+'		Dim nativeFamily As *GpFamily
+'		SetStatus(GdipGetFamily(nativeFont, nativeFamily))
+'		FontFamily = New FontFamily(nativeFamily)
 '	End Function
 
 	Const Function Bold() As Boolean
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
+		ToLogFont(lf)
 		Return lf.lfWeight > FW_BOLD
 	End Function
@@ -233,5 +183,5 @@
 	Const Function GdiCharSet() As Byte
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
+		ToLogFont(lf)
 		Return lf.lfCharSet
 	End Function
@@ -239,42 +189,41 @@
 	'Const Function GdiVerticalFont() As Boolean
 
-	Const Function NativeFont() As *GpFont
-		Return nativeFont
-	End Function
-
 	'Const Function IsSystemFont() As Boolean
 
 	Const Function Italic() As Boolean
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
-		Return lf.lfItalic <> FALSE
+		ToLogFont(lf)
+		Italic = lf.lfItalic <> FALSE
 	End Function
 
 	Const Function Name() As String
-#ifdef UNICODE
-		Dim lf As LOGFONTW
-		GetLogFontW(0, lf)
-#else
-		Dim lf As LOGFONTA
-		GetLogFontA(0, lf)
-#endif
-		Return lf.lfFaceName
-	End Function
-
-	'Const Function SizeInPoint() As Boolean
+		Dim lf As LOGFONT
+		ToLogFont(lf)
+		Dim p = lf.lfFaceName As PCTSTR
+		Name = New String(p)
+	End Function
 
 	Const Function StrikeOut() As Boolean
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
-		Return lf.fdwStrikeOut <> FALSE
+		ToLogFont(lf)
+		StrikeOut = lf.lfStrikeOut <> FALSE
 	End Function
 
 	Const Function Style() As FontStyle
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
-		Return (((lf.lfWeight > FW_BOLD) And FontStyle.Bold) Or _
-			((lf.lfItatlic <> FALSE) And FontStyle.Italic) Or _
-			((lf.fdwStrikeOut <> FALSE) And FontStyle.Strickeout) Or _
-			((lf.fdwUnderline <> FALSE) And FontStyle.Underline)) As FontStyle
+		ToLogFont(lf)
+		Style = FontStyle.Regular
+		If lf.lfWeight > FW_BOLD Then
+			Style Or= FontStyle.Bold
+		End If
+		If lf.lfItalic <> FALSE Then
+			Style Or= FontStyle.Italic
+		End If
+		If lf.lfStrikeOut <> FALSE Then
+			Style Or= FontStyle.Strikeout
+		End If
+		If lf.lfUnderline <> FALSE Then
+			Style Or= FontStyle.Underline
+		End If
 	End Function
 
@@ -283,51 +232,80 @@
 	Const Function Underline() As Boolean
 		Dim lf As LOGFONT
-		GetLogFont(0, lf)
-		Return lf.fdwUnderline <> FALSE
+		ToLogFont(lf)
+		Underline = lf.lfUnderline <> FALSE
 	End Function
 
 	Override Function ToString() As String
-		Return Name
+		ToString = Name
 	End Function
 
 	Const Function ToHfont() As HFONT
 		Dim lf As LOGFONT
-		GetLogFont(ByVal 0, lf)
-		Return CreateFontIndirect(lf)
-	End Function
-
-	Const Sub ToLogFont(ByRef lf As LOGFONT)
-		GetLogFont(ByVal 0, lf)
-	End Sub
-
-	Const Sub ToLogFont(ByRef lf As LOGFONT, g As Graphics)
-		GetLogFont(g, lf)
-	End Sub
+		ToLogFont(lf)
+		ToHfont = CreateFontIndirect(lf)
+	End Function
+
+	Const Sub ToLogFont(/*OUT*/ ByRef lf As LOGFONTA, /*IN const*/ g As Graphics)
+		Dim nativeGraphics = getNativeGraphics(g)
+		SetStatus(GdipGetLogFontA(nativeFont, nativeGraphics, lf))
+	End Sub
+
+	Const Sub ToLogFont(/*OUT*/ ByRef lf As LOGFONTW, /*IN const*/ g As Graphics)
+		Dim nativeGraphics = getNativeGraphics(g)
+		SetStatus(GdipGetLogFontW(nativeFont, nativeGraphics, lf))
+	End Sub
+
+	Const Sub ToLogFont(ByRef lf As LOGFONTA)
+		ToLogFont(lf, Nothing)
+	End Sub
+
+	Const Sub ToLogFont(ByRef lf As LOGFONTW)
+		ToLogFont(lf, Nothing)
+	End Sub
+
+	Function NativeFont() As *GpFont
+		NativeFont = nativeFont
+	End Function
 
 Private
-'	Sub Font(ByRef f As Font)
-
-Protected
-	Sub Font(f As *GpFont, status As Status)
-		lastResult = status
-		SetNativeFont(f)
-	End Sub
-
-	Sub SetNativeFont(f As *GpFont)
-		nativeFont = f
-	End Sub
-
-	Const Function SetStatus(s As Status) As Status
-		If s <> Status.Ok Then
-			lastResult = s
-			Return s
+	Sub initFont(/*IN const*/ family As FontFamily, /*IN*/ emSize As Single,
+		/*IN*/ style As Long, /*IN*/ unit As GraphicsUnit)
+
+		If ActiveBasic.IsNothing(family) Then
+			Throw New ArgumentNullException("family")
+		End If
+		SetStatus(GdipCreateFont(family.NativeFamily, emSize, style, unit, nativeFont))
+	End Sub
+
+	Sub initFromName(/*IN const*/ familyName As PCWSTR, /*IN*/ emSize As Single,
+		/*IN*/ style As Long, /*IN*/ unit As GraphicsUnit, fontCollection As FontCollection)
+
+		nativeFont = 0
+		Dim family = Nothing As FontFamily
+		Dim nativeFamily = family.NativeFamily
+
+		Try
+			family = New FontFamily(familyName, fontCollection)
+		Catch e As Exception
+			nativeFamily = FontFamily.GenericSansSerif().NativeFamily
+		End Try
+
+		Try
+			SetStatus(GdipCreateFont(nativeFamily, emSize, style, unit, nativeFont))
+		Catch e As Exception
+			nativeFamily = FontFamily.GenericSansSerif().NativeFamily
+			SetStatus(GdipCreateFont(nativeFamily, emSize, style, unit, nativeFont))
+		End Try
+	End Sub
+
+	Static Function getNativeGraphics(g As Graphics) As *GpGraphics
+		If ActiveBasic.IsNothing(g) Then
+			getNativeGraphics = 0
 		Else
-			Return s
-		End If
-	End Function
-
-Protected
+			getNativeGraphics = g.NativeGraphics
+		End If
+	End Function
+
 	nativeFont As *GpFont
-	/*mutable*/ lastResult As Status
 End Class
 
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/FontFamily.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/FontFamily.ab	(revision 698)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/FontFamily.ab	(revision 698)
@@ -0,0 +1,118 @@
+' Classes/System/Drawing/FontFamily.ab
+
+Namespace System
+Namespace Drawing
+
+Class FontFamily
+	Implements IDisposable, ICloneable
+Public
+	Sub FontFamily(native As *GpFontFamily)
+		nativeFamily = native
+	End Sub
+
+	Sub FontFamily(/*IN const*/ name As PCWSTR, fontCollection As FontCollection)
+		SetStatus(GdipCreateFontFamilyFromName(name, getNativeCollection(fontCollection), nativeFamily))
+	End Sub
+
+	Static Function GenericSansSerif() As FontFamily
+		If ActiveBasic.IsNothing(GenericSansSerifFontFamily) Then
+			Dim native As *GpFontFamily
+			SetStatus(GdipGetGenericFontFamilySansSerif(native))
+			GenericSansSerifFontFamily = New FontFamily(native)
+		End If
+		GenericSansSerif = GenericSansSerifFontFamily
+	End Function
+
+	Static Function GenericSerif() As FontFamily
+		If ActiveBasic.IsNothing(GenericSerifFontFamily) Then
+			Dim native As *GpFontFamily
+			SetStatus(GdipGetGenericFontFamilySerif(native))
+			GenericSerifFontFamily = New FontFamily(native)
+		End If
+		GenericSerif = GenericSerifFontFamily
+	End Function
+
+	Static Function GenericMonospace() As FontFamily
+		If ActiveBasic.IsNothing(GenericMonospaceFontFamily) Then
+			Dim native As *GpFontFamily
+			SetStatus(GdipGetGenericFontFamilyMonospace(native))
+			GenericMonospaceFontFamily = New FontFamily(native)
+		End If
+		GenericMonospace = GenericMonospaceFontFamily
+	End Function
+
+	Sub Dispose()
+		If nativeFamily <> 0 Then
+			GdipDeleteFontFamily(nativeFamily)
+		End If
+		nativeFamily = 0
+	End Sub
+
+	Sub ~FontFamily()
+		Dispose()
+	End Sub
+
+	Function Clone() As FontFamily
+		Dim cloned As *GpFontFamily
+		SetStatus(GdipCloneFontFamily(nativeFamily, cloned))
+		Clone = New FontFamily(cloned)
+	End Function
+
+	Function GetName(language As LANGID) As String
+		Dim name[ELM(LF_FACESIZE)] As WCHAR
+		SetStatus(GdipGetFamilyName(nativeFamily, name, language))
+		Dim p = name As PCWSTR
+		GetName = New String(p)
+	End Function
+
+	Function IsStyleAvailable(style As FontStyle) As Boolean
+		Dim StyleAvailable As BOOL
+		SetStatus(GdipIsStyleAvailable(nativeFamily, style, StyleAvailable))
+		IsStyleAvailable = StyleAvailable As Boolean
+	End Function
+
+	Function GetEmHeight(style As FontStyle) As Word
+		SetStatus(GdipGetEmHeight(nativeFamily, style, GetEmHeight))
+	End Function
+/*
+	Function GetCellAscent(style As FontStyle) As Word
+		SetStatus(GdipGetCellAscent(nativeFamily, style, GetEmHeight))
+	End Function
+
+	Function GetCellDescent(style As FontStyle) As Word
+		SetStatus(GdipGetCellDescent(nativeFamily, style, GetEmHeight))
+	End Function
+
+
+	Function GetLineSpacing(style As FontStyle) As Word
+		SetStatus(GdipGetLineSpacing(nativeFamily, style, GetEmHeight))
+	End Function
+*/
+	' Familes
+
+	Function NativeFamily() As *GpFontFamily
+		NativeFamily = nativeFamily
+	End Function
+
+Private
+
+	nativeFamily As *GpFontFamily
+
+	Static Function getNativeCollection(fc As FontCollection) As *GpFontCollection
+		If ActiveBasic.IsNothing(fc) Then
+			getNativeCollection = 0
+		Else
+			getNativeCollection = fc.nativeCollection
+		End If
+	End Function
+
+	Static GenericSansSerifFontFamily = Nothing As FontFamily
+	Static GenericSerifFontFamily = Nothing As FontFamily
+	Static GenericMonospaceFontFamily = Nothing As FontFamily
+
+End Class
+
+
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 698)
@@ -4,13 +4,54 @@
 Namespace Drawing
 
-Class Brush : End Class
-Class Pen : End Class
-Class StringFormat : End Class
-Class Image : End Class
-Class ImageAttributes : End Class
-Class Metafile : End Class
-Class Region : End Class
-Class GraphicsPath : End Class
-Class CachedBitmap : End Class
+Class Brush
+Public
+	nativeBrush As *GpBrush
+End Class
+Class StringFormat
+Public
+	nativeFormat As *GpStringFormat	
+End Class
+Class Image
+Public
+	nativeImage As *GpImage
+End Class
+Class ImageAttributes
+Public
+	nativeImage As *GpImageAttributes
+End Class
+Class Metafile
+Inherits Image
+End Class
+Class Region
+Public
+	nativeRegion As *GpRegion
+End Class
+Class GraphicsPath
+Public
+	nativePath As *GpPath
+End Class
+Class CachedBitmap
+Public
+	nativeCachedBitmap As *GpCachedBitmap
+End Class
+
+Delegate Function EnumerateMetafileProc(recordType As EmfPlusRecordType, flags As DWord, dataSize As DWord, data As *Byte, callbackData As VoidPtr) As Boolean
+
+Namespace Detail
+
+TypeDef NativeEnumerateMetafileProc = *Function(recordType As EmfPlusRecordType, flags As DWord, dataSize As DWord, data As *Byte, callbackData As VoidPtr) As Boolean
+
+Type EnumerateMetafileProcData
+	Proc As EnumerateMetafileProc
+	Data As VoidPtr
+End Type
+
+Function NativeEnumerateMetafileProcEntry(recordType As EmfPlusRecordType, flags As DWord, dataSize As DWord, data As *Byte, callbackData As VoidPtr) As Boolean
+	Dim procData = callbackData As *EnumerateMetafileProcData
+	Dim proc = procData->Proc
+	NativeEnumerateMetafileProcEntry = proc(recordType, flags, dataSize, data, procData->Data)
+End Function
+
+End Namespace
 
 Class Graphics
@@ -20,147 +61,142 @@
 	'=========================================================================
 	Const Function Clip() As Region
-		Dim r As Region
-		GetClip(r)
-		Return r
-	End Function
-
-	Sub Clip(region As /*Const*/ Region)
-		SetClip(region, CombineMode.Replace)
+		Clip = New Region
+		SetStatus(GdipGetClip(nativeGraphics, Clip.nativeRegion))
+	End Function
+
+	Sub Clip(region As Region)
+		Imports System.Drawing.Drawing2D
+		SetStatus(GdipSetClipRegion(nativeGraphics, region.nativeRegion, CombineMode.Replace))
 	End Sub
 
 	Const Function ClipBounds() As RectangleF
-		Dim rc As RectangleF
-		GetClipBounds(rc)
-		Return rc
-	End Function
-
-	Sub ClipBounds(rc As RectangleF)
-		SetClipBounds(rc)
-	End Sub
-
-	Function CompositingMode() As CompositingMode
-		Return GetCompositingMode()
-	End Function
-
-	Sub CompositingMode(mode As CompositingMode)
-		SetCompositingMode(mode)
-	End Sub
-
-	Function CompositingQuality() As CompositingQuality
-		Return GetCompositingQuality()
-	End Function
-
-	Sub CompositingQuality(cq As CompositingQuality)
-		SetCompositingQuality(cq)
-	End Sub
-
+		SetStatus(GdipGetClipBounds(nativeGraphics, ClipBounds))
+	End Function
+
+	Const Function ClipBoundsI() As Rectangle
+		SetStatus(GdipGetClipBoundsI(nativeGraphics, ClipBoundsI))
+	End Function
+/*
+	Const Function CompositingMode() As Drawing2D.CompositingMode
+		SetStatus(GdipGetCompositingMode(nativeGraphics, CompositingMode))
+	End Function
+
+	Sub CompositingMode(mode As Drawing2D.CompositingMode)
+		SetStatus(GdipSetCompositingMode(nativeGraphics, mode))
+	End Sub
+
+	Function CompositingQuality() As Drawing2D.CompositingQuality
+		SetStatus(GdipGetCompositingQuality(nativeGraphics, CompositingQuality))
+	End Function
+
+	Sub CompositingQuality(cq As Drawing2D.CompositingQuality)
+		Return SetStatus(GdipSetCompositingQuality(nativeGraphics, cq))
+	End Sub
+*/
 	Const Function DpiX() As Single
-		Dim dpi As Single
-		SetStatus(GdipGetDpiX(nativeGraphics, dpi))
-		Return dpi
+		SetStatus(GdipGetDpiX(nativeGraphics, DpiX))
 	End Function
 
 	Const Function DpiY() As Single
-		Dim dpi As Single
-		SetStatus(GdipGetDpiY(nativeGraphics, dpi))
-		Return dpi
-	End Function
-
-	Const Function InterpolationMode() As InterpolationMode
-		Return GetInterpolationMode()
-	End Function
-
-	Sub InterpolationMode(im As InterpolationMode)
-		SetInterpolationMode(im)
-	End Sub
-
-	Const Function IsClipEmpty() As BOOL
+		SetStatus(GdipGetDpiY(nativeGraphics, DpiY))
+	End Function
+/*
+	Const Function InterpolationMode() As Drawing2D.InterpolationMode
+		SetStatus(GdipGetInterpolationMode(nativeGraphics, InterpolationMode))
+	End Function
+
+	Sub InterpolationMode(im As Drawing2D.InterpolationMode)
+		InterpolationMode = SetStatus(GdipSetInterpolationMode(nativeGraphics, im))
+	End Sub
+*/
+	Const Function IsClipEmpty() As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsClipEmpty(nativeGraphics, b))
-		Return b
-	End Function
-
-	Const Function IsVisibleClipEmpty() As BOOL
+		IsClipEmpty = b As Boolean
+	End Function
+
+	Const Function IsVisibleClipEmpty() As Boolean
 		Dim b = FALSE As BOOL
 		SetStatus(GdipIsVisibleClipEmpty(nativeGraphics, b))
-		Return b
-	End Function
-
-	Function PageScale(scale As Single) As Status
-		Return SetStatus(GdipSetPageScale(nativeGraphics, scale))
-	End Function
+		IsVisibleClipEmpty = b As Boolean
+	End Function
+
+	Sub PageScale(scale As Single)
+		SetStatus(GdipSetPageScale(nativeGraphics, scale))
+	End Sub
 
 	Const Function PageScale() As Single
-		Dim scale As Single
-		SetStatus(GdipGetPageScale(nativeGraphics, scale))
-		Return scale
-	End Function
-
+		SetStatus(GdipGetPageScale(nativeGraphics, PageScale))
+	End Function
+/*
 	Const Function PageUnit() As GraphicsUnit
-		Dim unit As GraphicsUnit
-		SetStatus(GdipGetPageUnit(nativeGraphics, unit))
-		Return unit
-	End Function
-
-	Function PageUnit(unit As GraphicsUnit) As Status
-		Return SetStatus(GdipSetPageUnit(nativeGraphics, unit))
-	End Function
-
-	Function PixelOffsetMode() As PixelOffsetMode
-		Return GetPixelOffsetMode()
-	End Function
-
-	Sub PixelOffsetMode(mode  As PixelOffsetMode)
-		SetPixelOffsetMode(mode)
+		SetStatus(GdipGetPageUnit(nativeGraphics, PageUnit))
+	End Function
+*/
+	Sub PageUnit(unit As GraphicsUnit)
+		SetStatus(GdipSetPageUnit(nativeGraphics, unit))
+	End Sub
+/*
+	Function PixelOffsetMode() As Drawing2D.PixelOffsetMode
+		PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.Invalid
+		SetStatus(GdipGetPixelOffsetMode(nativeGraphics, PixelOffsetMode))
+	End Function
+*/
+	Sub PixelOffsetMode(mode As Drawing2D.PixelOffsetMode)
+		SetStatus(GdipSetPixelOffsetMode(nativeGraphics, mode))
 	End Sub
 
 	Function RenderingOrigin() As Point
-		Dim pt As Point
-		GetRenderingOrigin(pt.X, pt.Y)
-		Return pt
+		With RenderingOrigin
+			.X = 0
+			.Y = 0
+			SetStatus(GdipGetRenderingOrigin(nativeGraphics, .X, .Y))
+		End With
 	End Function
 
 	Sub RenderingOrigin(pt As Point)
-		SetRenderingOrigin(pt.X, pt.Y)
-	End Sub
-
-	Function SmoothingMode() As SmoothingMode
-		Return GetSmoothingMode()
-	End Function
-
-	Sub SmoothingMode(mode As SmoothingMode)
-		SetSmoothingMode(mode)
+		SetStatus(GdipSetRenderingOrigin(nativeGraphics, pt.X, pt.Y))
+	End Sub
+/*
+	Function SmoothingMode() As Drawing2D.SmoothingMode
+		SetStatus(GdipGetSmoothingMode(nativeGraphics, SmoothingMode))
+	End Function
+*/
+	Sub SmoothingMode(mode As Drawing2D.SmoothingMode)
+		SetStatus(GdipSetSmoothingMode(nativeGraphics, mode))
 	End Sub
 
 	Function TextContrast() As DWord
-		Return GetTextContrast()
+		SetStatus(GdipGetTextContrast(nativeGraphics, TextContrast))
 	End Function
 
 	Sub TextContrast(contrast As DWord)
-		SetTextContrast(contrast)
-	End Sub
-
-	Function TextRenderingHint() As TextRenderingHint
-		Return GetTextRenderingHint()
-	End Function
-
+		SetStatus(GdipSetTextContrast(nativeGraphics, contrast))
+	End Sub
+/*
+	Function TextRenderingHint() As Text.TextRenderingHint
+		SetStatus(GdipGetTextRenderingHint(nativeGraphics, ByVal VarPtr(TextRenderingHint)))
+	End Function
+*/
 	Sub TextRenderingHint(mode As TextRenderingHint)
-		SetTextRenderingHint(mode)
-	End Sub
-
-	Function Transform() As Matrix
-		Dim matrix As Matrix
-		GetTransform(matrix)
-		Return matrix
-	End Function
-
-	Sub Transform(matrix As Matrix)
-		SetTransform(matirx)
+		SetStatus(GdipSetTextRenderingHint(nativeGraphics, mode))
+	End Sub
+
+	Function Transform() As Drawing2D.Matrix
+		Dim native As *GpMatrix
+		SetStatus(GdipGetWorldTransform(nativeGraphics, native))
+		Transform = New Drawing2D.Matrix(native)
+	End Function
+
+	Sub Transform(matrix As Drawing2D.Matrix)
+		SetStatus(GdipSetWorldTransform(nativeGraphics, matrix.nativeMatrix))
 	End Sub
 
 	Function VisibleClipBounds() As RectangleF
-		Dim rc As RectangleF
-		GetVisibleClipBounds(rc)
-		Return rc
+		SetStatus(GdipGetVisibleClipBounds(nativeGraphics, VisibleClipBounds))
+	End Function
+
+	Function VisibleClipBoundsI() As Rectangle
+		SetStatus(GdipGetVisibleClipBoundsI(nativeGraphics, VisibleClipBoundsI))
 	End Function
 
@@ -169,81 +205,60 @@
 	'=========================================================================
 	Static Function FromHDC(hdc As HDC) As Graphics
-		Return New Graphics(hdc)
+		Dim graphics = 0 As *GpGraphics
+		SetStatus(GdipCreateFromHDC(hdc, graphics))
+		Return New Graphics(graphics)
 	End Function
 
 	Static Function FromHDC(hdc As HDC, hdevice As HANDLE) As Graphics
-		Return New Graphics(hdc, hdevice)
-	End Function
-
-	Static Function FromHWND(hwnd As HWND) As Graphics
-		Return New Graphics(hwnd, FALSE)
-	End Function
-
-	Static Function FromHWND(hwnd As DWord, icm As BOOL) As Graphics
-		Return New Graphics(hwnd, icm)
+		Dim graphics = 0 As *GpGraphics
+		SetStatus(GdipCreateFromHDC2(hdc, hdevice, graphics))
+		Return New Graphics(graphics)
+	End Function
+
+	Static Function FromHwnd(hwnd As HWND) As Graphics
+		Dim graphics = 0 As *GpGraphics
+		SetStatus(GdipCreateFromHWND(hwnd, graphics))
+		Return New Graphics(graphics)
+	End Function
+
+	Static Function FromHwnd(hwnd As HWND, icm As Boolean) As Graphics
+		Dim graphics = 0 As *GpGraphics
+		If icm Then
+			SetStatus(GdipCreateFromHWNDICM(hwnd, graphics))
+		Else
+			SetStatus(GdipCreateFromHWND(hwnd, graphics))
+		End If
+		Return New Graphics(graphics)
 	End Function
 
 	Static Function FromImage(image As Image) As Graphics
-		Return New Graphics(image)
-	End Function
-
-	Sub Graphics(hdc As HDC)
-		Dim graphics = 0 As GpGraphics
-		lastResult = GdipCreateFromHDC(hdc, graphics)
-		SetNativeGraphics(graphics)
-	End Sub
-
-	Sub Graphics(hdc As HDC, hdevice As HANDLE)
+		If ActiveBasic.IsNothing(image) Then
+			Throw New ArgumentNullException("image")
+		End If
 		Dim graphics = 0 As *GpGraphics
-		lastResult = GdipCreateFromHDC2(hdc, hdevice, graphics)
-		SetNativeGraphics(graphics)
-	End Sub
-
-	Sub Graphics(hwnd As HWND)
-		Dim graphics = 0 As *GpGraphics
-		lastResult = GdipCreateFromHWND(hwnd, graphics)
-		SetNativeGraphics(graphics)
-	End Sub
-
-	Sub Graphics(hwnd As HWND, icm As BOOL)
-		Dim graphics = 0 As *GpGraphics
-		If icm <> FALSE Then
-			lastResult = GdipCreateFromHWNDICM(hwnd, graphics)
-		Else
-			lastResult = GdipCreateFromHWND(hwnd, graphics)
-		End If
-		SetNativeGraphics(graphics)
-	End Sub
-
-	Sub Graphics(image As Image)
-		Dim graphics = 0 As *GpGraphics
-		If (image != 0)
-			lastResult = GdipGetImageGraphicsContext(image->NativeImage, graphics)
-		End If
-		SetNativeGraphics(graphics)
+		SetStatus(GdipGetImageGraphicsContext(image.nativeImage, graphics))
+		Return New Graphics(graphics)
+	End Function
+
+	Sub Dispose()
+		GdipDeleteGraphics(nativeGraphics)
+		nativeGraphics = 0
 	End Sub
 
 	Sub ~Graphics()
-		GdipDeleteGraphics(nativeGraphics)
+		Dispose()
 	End Sub
 
 	Sub Flush()
-		GdipFlush(nativeGraphics, FlushIntention.Flush)
-	End Sub
-
-	Sub Flush(intention As FlushIntention)
+		GdipFlush(nativeGraphics, System.Drawing.Drawing2D.FlushIntention.Flush)
+	End Sub
+
+	Sub Flush(intention As Drawing2D.FlushIntention)
 		GdipFlush(nativeGraphics, intention)
 	End Sub
 
-	'------------------------------------------------------------------------
-	' GDI Interop methods
-	'------------------------------------------------------------------------
-
-	' Locks the graphics until ReleaseDC is called
-
 	Function GetHDC() As HDC
-		Dim hdc = 0 As HDC
-		SetStatus(GdipGetDC(nativeGraphics, hdc))
-		Return hdc
+		GetHDC = 0
+		SetStatus(GdipGetDC(nativeGraphics, GetHDC))
 	End Function
 
